SGATCC/Areas/Coordenador/Controllers/RelatorioController.cs
using Microsoft.AspNetCore.Authorization;
using Microsoft.AspNetCore.Mvc;
using Microsoft.AspNetCore.Mvc.Rendering;
using Microsoft.EntityFrameworkCore;
using Rotativa.AspNetCore;
using SGATCC.Areas.Coordenador.ViewModel;
using SGATCC.Contexto;
using System;
using System.Collections.Generic;
using System.Linq;

namespace SGATCC.Areas.Coordenador.Controllers
{
    [Area("Coordenador")]
    [Authorize(Roles = "Coordenador,Professor")]
    public class RelatorioController : Controller
    {
        private readonly ContextoSGATCC _context;

        public RelatorioController(ContextoSGATCC context)
        {
            _context = context;
        }
        public IActionResult Grade()
        {
            var dadosCursos = _context.Cursos.ToList();
            var listaCursos = new List<SelectListItem> { new SelectListItem { Text = "Selecione o Curso", Value = "" } };
            listaCursos.AddRange(dadosCursos.Select(x => new SelectListItem { Text = x.Descricao, Value = x.Id.ToString() }));

            ViewBag.Cursos = listaCursos;
            return View();
        }

        [HttpPost]
        public IActionResult BuscarAlunos(GradeFiltroViewModel viewModel)
        {
            var lstAlunos = _context.Alunos
                .Include(x => x.Curso)
                .Include(x => x.Turno).Where(x => x.CursoId == viewModel.CursoId).ToList();

            if (!string.IsNullOrEmpty(viewModel.Matricula))
                lstAlunos.FirstOrDefault(x => x.Matricula.ToLower().Contains(viewModel.Matricula.ToLower()));

            return PartialView("_lstAlunos", lstAlunos);
        }

        [HttpGet]
        public IActionResult PdfView(int alunoId, int cursoId)
        {
            var aluno = _context.Alunos.FirstOrDefault(x => x.Id == alunoId);
            var curso = _context.Cursos.Include(x => x.Disciplinas).FirstOrDefault(x => x.Id == cursoId);

            var pdf = new PdfViewModel();
            pdf.Nome = aluno.Nome;
            pdf.Matricula = aluno.Matricula;
            pdf.Curso = curso.Descricao;
            pdf.Data = DateTime.Now.ToString("dd/MM/yyyy");


            foreach (var item in curso.Disciplinas)
            {
                var aula = _context.Aulas.FirstOrDefault(y => y.DisciplinaId == item.Id && y.AlunoId == aluno.Id);
                var nota = _context.Notas.FirstOrDefault(y => y.DisciplinaId == item.Id && y.AlunoId == aluno.Id);

                if(aula != null && nota != null)
                {
                    int faltas = 0;
                    if (!aula.FreqAula1)
                        faltas++;

                    if (!aula.FreqAula2)
                        faltas++;

                    if (!aula.FreqAula3)
                        faltas++;

                    if (!aula.FreqAula4)
                        faltas++;

                    if (!aula.FreqAula5)
                        faltas++;

                    pdf.Materias.Add(new pdfMateriaViewModel
                    {
                        Disciplina = item.Descricao,
                        Faltas = faltas,
                        Nota = nota.ValorNota,
                        Situacao = nota.ValorNota >= 70 ? "Aprovado" : "Reprovado"

                    });
                }
            }
            return new ViewAsPdf("PdfView",pdf) { FileName = $"{pdf.Nome}.pdf"};
        }
    }
}

SGATCC/Areas/Coordenador/Views/Relatorio/Grade.cshtml
@model GradeFiltroViewModel

<div class="card">
    <div class="card-header card-admin">
        <div class="card-title">
            Grade
        </div>
    </div>
    <div class="card-body">
        <form asp-action="BuscarAlunos" asp-controller="Relatorio" asp-area="Coordenador" data-ajax="true"
              data-ajax-method="post"
              data-ajax-update="#resultado"
              data-ajax-begin="gradeBegin"
              data-ajax-success="gradeSuccess"
              id="formAlunos">
            <div class="row">
                <div class="col-md-3">
                    <label asp-for="CursoId"></label>
                    <select asp-for="CursoId" asp-items="ViewBag.Cursos" class="form-control"></select>
                </div>
                <div class="col-md-3">
                    <label asp-for="Matricula"></label>
                    <input asp-for="Matricula" class="form-control" placeholder="opcional" />
                </div>
            </div>
            <br />

            <div class="row">
                <div class="col-md-6">
                    <input class="btn btn-success" type="submit" value="Buscar" />
                </div>
            </div>
        </form>
    </div>
</div>

<div id="resultado">

</div>

<script>
    function gradeBegin() {
        $("#formAlunos").loading();
    }
    function gradeSuccess() {
        $("#formAlunos").loading('stop');
    }
</script>

SGATCC/Areas/Coordenador/Views/Relatorio/PdfView.cshtml
@model PdfViewModel

@{
    Layout = null;
}

<!Doctype html>
<html>

<link rel="stylesheet" href="~/lib/bootstrap/dist/css/bootstrap.css" />
<link rel="stylesheet" href="https://stackpath.bootstrapcdn.com/bootstrap/4.3.1/css/bootstrap.min.css"
      asp-fallback-href="~/lib/bootstrap/dist/css/bootstrap.min.css"
      asp-fallback-test-class="sr-only" asp-fallback-test-property="position" asp-fallback-test-value="absolute"
      crossorigin="anonymous"
      integrity="sha384-ggOyR0iXCbMQv3Xipma34MD+dH/1fQ784/j6cY/iJTQUOhcWr7x9JvoRxT2MZw1T" />

<link rel="stylesheet" href="~/css/site.css" />
<!-- Custom fonts for this template-->
<link href="~/vendor/fontawesome-free/css/all.min.css" rel="stylesheet" type="text/css">
<link href="https://fonts.googleapis.com/css?family=Nunito:200,200i,300,300i,400,400i,600,600i,700,700i,800,800i,900,900i" rel="stylesheet">

<!-- Custom styles for this template-->
<link href="~/css/sb-admin-2.min.css" rel="stylesheet">
<link href="~/site.css" rel="stylesheet">

<head>

</head>

<body>
    <div class="text-center">
        <i class="fas fa-graduation-cap fa-5x"></i>
        <h5>SGA</h5>
    </div>
    <div class="card">
        <div class="card-header card-admin">
            <div class="card-title">
                <h5>Grade Currícular</h5>
            </div>
        </div>
        <div id="pdfContainer" class="card-body">
            <div class="row">
                <div class="col-md-3">
                    <label asp-for="Curso"></label>
                    <input asp-for="Curso" class="form-control" readonly />
                </div>
                <div class="col-md-3">
                    <label asp-for="Nome"></label>
                    <input asp-for="Nome" class="form-control" readonly />
                </div>
                <div class="col-md-3">
                    <label asp-for="Matricula"></label>
                    <input asp-for="Matricula" class="form-control" readonly />
                </div>
                <div class="col-md-3">
                    <label asp-for="Data"></label>
                    <input asp-for="Data" class="form-control" readonly />
                </div>
            </div>
            <br />
            <div>
                <table class="table">

                    <thead>
                        <tr>
                            <th>
                                @Html.DisplayNameFor(Model => Model.Materias.FirstOrDefault().Disciplina)
                            </th>
                            <th>
                                @Html.DisplayNameFor(Model => Model.Materias.FirstOrDefault().Faltas)
                            </th>
                            <th>
                                @Html.DisplayNameFor(Model => Model.Materias.FirstOrDefault().Nota)
                            </th>
                            <th>
                                @Html.DisplayNameFor(Model => Model.Materias.FirstOrDefault().Situacao)
                            </th>
                        </tr>
                    </thead>
                    @foreach (var item in Model.Materias)
                    {
                        <tbody>
                            <tr>
                                <td>
                                    @Html.DisplayFor(Model => item.Disciplina)
                                </td>
                                <td>
                                    @Html.DisplayFor(Model => item.Faltas)
                                </td>
                                <td>
                                    @Html.DisplayFor(Model => item.Nota)
                                </td>
                                <td>
                                    @Html.DisplayFor(Model => item.Situacao)
                                </td>
                            </tr>
                        </tbody>
                    }
                </table>
            </div>
        </div>
    </div>
</body>
</html>

SGATCC/Areas/Coordenador/Views/Relatorio/_lstAlunos.cshtml
@model List<Aluno>

<div class="card">
    <div class="card-header card-admin">
        <div class="card-title">
            Alunos
        </div>
    </div>
    <div class="card-body">
        <table class="table" id="tableAlunos">

            <thead>
                <tr>
                    <th>
                        Ações
                    </th>
                    <th>
                        @Html.DisplayNameFor(Model => Model.FirstOrDefault().Matricula)
                    </th>
                    <th>
                        @Html.DisplayNameFor(Model => Model.FirstOrDefault().Nome)
                    </th>
                    <th>
                        @Html.DisplayNameFor(Model => Model.FirstOrDefault().DataNascimento)
                    </th>
                    <th>
                        @Html.DisplayNameFor(Model => Model.FirstOrDefault().Curso.Descricao)
                    </th>
                    <th>
                        @Html.DisplayNameFor(Model => Model.FirstOrDefault().TurnoId)
                    </th>
                </tr>
            </thead>
            @foreach (var item in Model)
            {
                <tbody>
                    <tr>
                        <td>
                            <a asp-action="PdfView"  style="color:#da210d" asp-route-alunoId="@item.Id"asp-route-cursoId="@item.CursoId" title="Download Grade" class="fas fa-file-pdf downloadPDF"></a>
                        </td>
                        <td>
                            @Html.DisplayFor(Model => item.Matricula)
                        </td>
                        <td>
                            @Html.DisplayFor(Model => item.Nome)
                        </td>
                        <td>
                            @Html.DisplayFor(Model => item.DataNascimento)
                        </td>
                        <td>
                            @Html.DisplayFor(Model => item.Curso.Descricao)
                        </td><td>
                            @Html.DisplayFor(Model => item.Turno.Descricao)
                        </td>
                    </tr>
                </tbody>
            }
        </table>
    </div>
</div>